package fwadmin;

/*

  JFwadmin v 0.82

  Copyright (C) 1999-2000 Mickael Feledyn
  		     mickael.feledyn@cybergal.com

  This application is free software; you can redistribute it and/or
  modify it under the terms of the GNU Genereal Public License as
  published by the Free Software Foundation; either version 2 of
  the License, or (at your option) any later version.

  This application is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

*/

public class RuleComparator implements java.util.Comparator
{
/**
 * InputOutputRuleComparator constructor comment.
 */
public RuleComparator() {
	super();
}
public int compare(Object _o1, Object _o2)
{
	Rule o1 = (Rule) _o1;
	Rule o2 = (Rule) _o2;

 	// Order on interface name
 	if (o1.m_interfaceName.compareTo(o2.m_interfaceName) != 0) return (o1.m_interfaceName.compareTo(o2.m_interfaceName));

 	// Anti spoofing rules come first
 	if (o1.mb_antiSpoofingRule && (!o2.mb_antiSpoofingRule)) return -70000;
 	if (o2.mb_antiSpoofingRule && (!o1.mb_antiSpoofingRule)) return 70000;
 	// Log denied packets rules come last
 	if (o1.mb_logDeniedPacketsRule && (!o2.mb_logDeniedPacketsRule)) return 70000;
 	if (o2.mb_logDeniedPacketsRule && (!o1.mb_logDeniedPacketsRule)) return -70000;
	
 	// Misc rules come last
 	if (o1.m_affectedToService && (! o2.m_affectedToService)) return -1;
 	if (o2.m_affectedToService && (! o1.m_affectedToService)) return 1;
 	// Order on protocol
 	if (o1.m_protocol != o2.m_protocol) return (o1.m_protocol - o2.m_protocol);
 	// Order on service destination port
 	if (o1.m_destinationHighPort != o2.m_destinationHighPort) return (o1.m_destinationHighPort - o2.m_destinationHighPort);
 	if (o1.m_destinationLowPort != o2.m_destinationLowPort) return (o1.m_destinationLowPort - o2.m_destinationLowPort);
 	// Order on service source port
 	if (o1.m_sourceHighPort != o2.m_sourceHighPort) return (o1.m_sourceHighPort - o2.m_sourceHighPort);
 	if (o1.m_sourceLowPort != o2.m_sourceLowPort) return (o1.m_sourceLowPort - o2.m_sourceLowPort);
 	// Order on service destination address
 	if (o1.m_destinationAddress.getLong() != o2.m_destinationAddress.getLong()) return ((int)(o1.m_destinationAddress.getLong() - o2.m_destinationAddress.getLong()));
 	// Order on service source address
 	if (o1.m_sourceAddress.getLong() != o2.m_sourceAddress.getLong()) return ((int)(o1.m_sourceAddress.getLong() - o2.m_sourceAddress.getLong()));
 	// Order on service destination mask
 	if (o1.m_destinationMask.getLong() != o2.m_destinationMask.getLong()) return ((int)(o1.m_destinationMask.getLong() - o2.m_destinationMask.getLong()));
 	// Order on service source mask
 	if (o1.m_sourceMask.getLong() != o2.m_sourceMask.getLong()) return ((int)(o1.m_sourceMask.getLong() - o2.m_sourceMask.getLong()));

 	// Order on rule type (input or output or forward)
 	if (o1.m_ruleType.compareTo(o2.m_ruleType) != 0) return (o1.m_ruleType.compareTo(o2.m_ruleType));
 	// Order on policy (ACCEPT or DENY)
 	if (o1.m_policy.compareTo(o2.m_policy) != 0) return (o1.m_policy.compareTo(o2.m_policy));
 	// Order on rule flags (logging)
 	if (o1.m_flags != o2.m_flags) return (o1.m_flags - o2.m_flags);
 	if (o1.m_flags2 != o2.m_flags2) return (o1.m_flags2 - o2.m_flags2);
 	
 	return 0;
}
}
